/*
 *
 * BRIEF MODULE DESCRIPTION
 *	E!Kit-1100 board setup.
 *
 * Copyright 2003-2005 Device Drivers Limited.
 * Author: kawamoto@devdrv.co.jp
 *
 * This program is largely copies by the Db1x00 source files.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <linux/config.h>
#include <linux/init.h>
#include <linux/sched.h>
#include <linux/ioport.h>
#include <linux/mm.h>
#include <linux/console.h>
#include <linux/mc146818rtc.h>
#include <linux/delay.h>

#include <asm/cpu.h>
#include <asm/bootinfo.h>
#include <asm/irq.h>
#include <asm/mipsregs.h>
#include <asm/reboot.h>
#include <asm/pgtable.h>
#include <asm/mach-au1x00/au1000.h>
#include <asm/mach-ekit1100/ekit1100.h>

static BCSR * const bcsr = (BCSR *)0xB8000000;

void board_reset (void)
{
	bcsr->sys = 0x0000000F;
}

void __init board_setup(void)
{
	au_writel(3, UART1_ADDR + UART_MOD_CNTRL); /* uart1_enable ;( */
	
#if defined(CONFIG_MMC)
	au_writel((1 << 31) | (1 << 30) | (1 << 20) | (1 << 21), SYS_TRIOUTCLR);
	au_sync();
	au_writel((1 << 22) | (1 << 23), SYS_OUTPUTSET);
	au_sync();
#endif
	
#if defined(CONFIG_MIPS_RTC)
	bcsr->gpio3 &= ~0x0000000F;
	au_sync();
	bcsr->gpio3 |=  0x000F0000;
	au_sync();
#endif
	
	printk("Device Drivers Limited E!Kit-1100 Board\n");
}
